"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class ShaNistTest(google.protobuf.message.Message):
    """A single SHA test vector."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LEN_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    MD_FIELD_NUMBER: builtins.int
    len: builtins.int
    """The length of the message in bits."""
    msg: builtins.bytes
    """The message to hash."""
    md: builtins.bytes
    """The resulting digest."""
    def __init__(
        self,
        *,
        len: builtins.int = ...,
        msg: builtins.bytes = ...,
        md: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["len", b"len", "md", b"md", "msg", b"msg"]) -> None: ...

global___ShaNistTest = ShaNistTest

@typing.final
class ShaNistVectors(google.protobuf.message.Message):
    """A file of NIST SHA vectors."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILENAME_FIELD_NUMBER: builtins.int
    TESTS_FIELD_NUMBER: builtins.int
    filename: builtins.str
    """The name of the source file."""
    @property
    def tests(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ShaNistTest]:
        """The test vectors."""

    def __init__(
        self,
        *,
        filename: builtins.str = ...,
        tests: collections.abc.Iterable[global___ShaNistTest] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filename", b"filename", "tests", b"tests"]) -> None: ...

global___ShaNistVectors = ShaNistVectors

@typing.final
class ShaMonteCarloNistVectors(google.protobuf.message.Message):
    """A file of NIST Monte-Carlo SHA vectors. Consists of one seed and several checkpoints."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CheckpointsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.int
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.int = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    FILENAME_FIELD_NUMBER: builtins.int
    SEED_FIELD_NUMBER: builtins.int
    CHECKPOINTS_FIELD_NUMBER: builtins.int
    filename: builtins.str
    """The name of the source file."""
    seed: builtins.bytes
    """The seed"""
    @property
    def checkpoints(self) -> google.protobuf.internal.containers.ScalarMap[builtins.int, builtins.bytes]:
        """A dictionary of checkpoints: the indexes are the keys, the checkpoints are the
        values.
        """

    def __init__(
        self,
        *,
        filename: builtins.str = ...,
        seed: builtins.bytes = ...,
        checkpoints: collections.abc.Mapping[builtins.int, builtins.bytes] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["checkpoints", b"checkpoints", "filename", b"filename", "seed", b"seed"]) -> None: ...

global___ShaMonteCarloNistVectors = ShaMonteCarloNistVectors

@typing.final
class ShakeNistTest(google.protobuf.message.Message):
    """A single NIST SHAKE vector."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LEN_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    OUTPUT_FIELD_NUMBER: builtins.int
    len: builtins.int
    """The length of the message in bits."""
    msg: builtins.bytes
    """The input message."""
    output: builtins.bytes
    """The resulting digest."""
    def __init__(
        self,
        *,
        len: builtins.int = ...,
        msg: builtins.bytes = ...,
        output: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["len", b"len", "msg", b"msg", "output", b"output"]) -> None: ...

global___ShakeNistTest = ShakeNistTest

@typing.final
class ShakeNistVectors(google.protobuf.message.Message):
    """A file of NIST SHAKE vectors."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILENAME_FIELD_NUMBER: builtins.int
    OUTPUT_LEN_FIELD_NUMBER: builtins.int
    TESTS_FIELD_NUMBER: builtins.int
    filename: builtins.str
    """The name of the source file."""
    output_len: builtins.int
    """The SHAKE variant."""
    @property
    def tests(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ShakeNistTest]:
        """A list of test vectors."""

    def __init__(
        self,
        *,
        filename: builtins.str = ...,
        output_len: builtins.int = ...,
        tests: collections.abc.Iterable[global___ShakeNistTest] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filename", b"filename", "output_len", b"output_len", "tests", b"tests"]) -> None: ...

global___ShakeNistVectors = ShakeNistVectors

@typing.final
class ShakeMonteNistVectors(google.protobuf.message.Message):
    """A file of NIST SHAKE Monte-Carlo vectors."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class CheckpointsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.int
        value: builtins.bytes
        def __init__(
            self,
            *,
            key: builtins.int = ...,
            value: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    FILENAME_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    MAX_LEN_FIELD_NUMBER: builtins.int
    MIN_LEN_FIELD_NUMBER: builtins.int
    CHECKPOINTS_FIELD_NUMBER: builtins.int
    filename: builtins.str
    """The name of the source file."""
    msg: builtins.bytes
    """The initial message."""
    max_len: builtins.int
    """The maximum length that is tested, in bits."""
    min_len: builtins.int
    """The minimum length that is tested, in bits."""
    @property
    def checkpoints(self) -> google.protobuf.internal.containers.ScalarMap[builtins.int, builtins.bytes]:
        """Maps the count to the output, outputlen must be re-computed."""

    def __init__(
        self,
        *,
        filename: builtins.str = ...,
        msg: builtins.bytes = ...,
        max_len: builtins.int = ...,
        min_len: builtins.int = ...,
        checkpoints: collections.abc.Mapping[builtins.int, builtins.bytes] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["checkpoints", b"checkpoints", "filename", b"filename", "max_len", b"max_len", "min_len", b"min_len", "msg", b"msg"]) -> None: ...

global___ShakeMonteNistVectors = ShakeMonteNistVectors

@typing.final
class ShakeVariableNistTest(google.protobuf.message.Message):
    """A single NIST SHAKE variable length test."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COUNT_FIELD_NUMBER: builtins.int
    OUTPUT_LEN_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    OUTPUT_FIELD_NUMBER: builtins.int
    count: builtins.int
    """The ID of the test."""
    output_len: builtins.int
    """The length of the output in bits."""
    msg: builtins.bytes
    """The input message."""
    output: builtins.bytes
    """The resulting digest."""
    def __init__(
        self,
        *,
        count: builtins.int = ...,
        output_len: builtins.int = ...,
        msg: builtins.bytes = ...,
        output: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["count", b"count", "msg", b"msg", "output", b"output", "output_len", b"output_len"]) -> None: ...

global___ShakeVariableNistTest = ShakeVariableNistTest

@typing.final
class ShakeVariableNistVectors(google.protobuf.message.Message):
    """A file of SHAKE NIST variable length vectors."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FILENAME_FIELD_NUMBER: builtins.int
    TESTS_FIELD_NUMBER: builtins.int
    filename: builtins.str
    """The name of the source file."""
    @property
    def tests(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ShakeVariableNistTest]:
        """A list of test vectors."""

    def __init__(
        self,
        *,
        filename: builtins.str = ...,
        tests: collections.abc.Iterable[global___ShakeVariableNistTest] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["filename", b"filename", "tests", b"tests"]) -> None: ...

global___ShakeVariableNistVectors = ShakeVariableNistVectors
